SEDSCRIPT=""

echo "Xpertmud Configure for QT-Only and Win32 Versions"
echo ""
echo "If you want to use Stlport, set \$STLPORT_INCLUDE."
SEDSCRIPT="$SEDSCRIPT; s'@STLPORT_INCLUDE@'$STLPORT_INCLUDE'g"

echo -n "Looking for qt make... "
QMAKEV=`qmake -h 2>/dev/null` 
if test ! -z "$QMAKEV" && test -z "$QTMAKE"; then
	QTMAKE=qmake
	echo "qmake."
	if test -z "$QT_INCLUDE"; then
		echo "Please set \$QT_INCLUDE"
		exit 1
	else
		ln -s $QT_INCLUDE/qtextedit.h compat/qtextedit-original.h
		SEDSCRIPT="$SEDSCRIPT; s'@TEXTEDIT_H@''g"
	fi
else
	SEDSCRIPT="$SEDSCRIPT; s'@TEXTEDIT_H@'compat/qtextedit.h'g"
	QMAKEV=`tmake -h 2>/dev/null`
	if test ! -z "$QMAKEV"; then
		QTMAKE=tmake
		echo "tmake."
	else
		QTMAKE=tmake
		echo "tmake."
		echo "If something doesn't work it's probably because of this negative tmake check..."
	fi
fi
SEDSCRIPT="$SEDSCRIPT; s'@QT_MAKE@'$QTMAKE'g"

echo -n "Looking for perl... "
if test -z "$PERL_INCLUDE" -o -z "$PERL_LIBS"; then
	echo "Please set \$PERL_INCLUDE and \$PERL_LIBS"
	exit 1
fi
echo "done."
SEDSCRIPT="$SEDSCRIPT;s'@PERL_INCLUDE@'$PERL_INCLUDE'g;"
SEDSCRIPT="$SEDSCRIPT;s'@PERL_LIBS@'$PERL_LIBS'g;"

echo -n "Looking for python... "
if test -z "$PYTHON_INCLUDE" -o -z "$PYTHON_LIBS"; then
	echo "Please set \$PYTHON_INCLUDE and \$PYTHON_LIBS"
	exit 1
fi
echo "done."
SEDSCRIPT="$SEDSCRIPT;s'@PYTHON_INCLUDE@'$PYTHON_INCLUDE'g;"
SEDSCRIPT="$SEDSCRIPT;s'@PYTHON_LIBS@'$PYTHON_LIBS'g;"

INSTDIR="xpertmud-win32"
echo "Setting install dir to $INSTDIR"
SEDSCRIPT="$SEDSCRIPT; s'@INST_DIR@'$INSTDIR'g"

MAKEQFILE="make -f"
BINSUFFIX=""
DLLSUFFIX=".so"
if test `uname -s` = "CYGWIN_NT-5.1"; then
	MAKEQFILE="nmake /f"
	BINSUFFIX=".exe"
	DLLSUFFIX=".dll"
fi

echo "Setting bin-suffix to \"$BINSUFFIX\"."
SEDSCRIPT="$SEDSCRIPT; s'@BIN_SUFFIX@'$BINSUFFIX'g"

echo "Setting dll-suffix to \"$DLLSUFFIX\"."
SEDSCRIPT="$SEDSCRIPT; s'@DLL_SUFFIX@'$DLLSUFFIX'g"

echo "Making qt make Makefiles with \"$MAKEQFILE\""
SEDSCRIPT="$SEDSCRIPT; s'@MAKEQFILE@'$MAKEQFILE'g"

echo "Using qt in: $QTDIR"
SEDSCRIPT="$SEDSCRIPT; s'@QT_DIR@'$QTDIR'g"

echo "CXXFLAGS=\"$CXXFLAGS\""
SEDSCRIPT="$SEDSCRIPT; s'@CXXFLAGS@'$CXXFLAGS'g"

# Escape the string
SEDSCRIPT=`echo $SEDSCRIPT |sed -e 's|\\\\|\\\\\\\\|g' `


MAKEDIRS=". xpertmud/scripting/perl xpertmud/scripting/python xpertmud/plugins/battletech"
for dir in $MAKEDIRS; do
	FILE=$dir/Makefile
	INFILE=$dir/Makefile.ms.gnu
	echo "Creating Makefile $FILE"
	cat $INFILE |sed -e "$SEDSCRIPT" > $FILE
done
TMAKEFILES="xpertmud.pro xpertmud/scripting/perl/libxmperlinterpreter.pro xpertmud/scripting/python/libxmpythoninterpreter.pro xpertmud/plugins/battletech/xmud_battletech.pro"
for file in $TMAKEFILES; do
	INFILE=$file.in
	echo "Creating tmake file $file"
	cat $INFILE |sed -e "$SEDSCRIPT" > $file
done
#echo $SEDSCRIPT