PERL = perl
TOPDIR = ..\..\..
INSTDIR = $(TOPDIR)\win32-bin

all: libxmperlinterpreter.dll

libxmperlinterpreter.dll: doCompile

doCompile: Makefile.nms sysinit_plf.h
	nmake /f Makefile.nms

Makefile.nms: libxmperlinterpreter.pro
	tmake -o Makefile.nms libxmperlinterpreter.pro

sysinit_plf.h: sysinit.pl
	$(PERL) -c sysinit.pl
	type sysinit.pl | $(PERL) pl2h.pl sysinit WIN32  > $@

onHelp.pl: interface.desc interface-base.desc interface-top.desc
	type  interface.desc interface-base.desc interface-top.desc | $(PERL) desc2online.pl online  > $@

sysinit_plf.h: sysinit.pl onHelp.pl

install: libxmperlinterpreter.dll
	-mkdir $(INSTDIR)\dll\interpreter	
	copy /Y libxmperlinterpreter.dll $(INSTDIR)\dll\interpreter
	-mkdir $(INSTDIR)\appdata\perl
	copy /Y bt3030.pl $(INSTDIR)\appdata\perl	
	copy /Y battletech.pl $(INSTDIR)\appdata\perl

clean: Makefile.nms
	nmake /f Makefile.nms clean
	-del /Q Makefile.nms
	-del /Q onHelp.pl
	-del /Q sysinit_plf.h
	
