PERL = perl
TOPDIR = ../../..
INSTDIR = $(TOPDIR)/@INST_DIR@
TMAKE = @QT_MAKE@

all: libxmperlinterpreter@DLL_SUFFIX@

libxmperlinterpreter@DLL_SUFFIX@: doCompile

doCompile: Makefile.nms sysinit_plf.h AutoGuiScriptingWrapper.cc AutoGuiScriptingWrapper.h AutoPerlInterpret.cc
	(unset MAKEFLAGS && @MAKEQFILE@ Makefile.nms)

Makefile.nms: libxmperlinterpreter.pro
	$(TMAKE) -o Makefile.nms libxmperlinterpreter.pro

sysinit_plf.h: sysinit.pl
	$(PERL) -c sysinit.pl
	cat sysinit.pl | $(PERL) pl2h.pl sysinit WIN32  > $@

onHelp.pl: ../help.desc ../help-base.desc ../help-toplevel.desc ../help-stepbystep.desc desc2online.pl
	cat ../help.desc | $(PERL) desc2online.pl online  > $@

sysinit_plf.h: sysinit.pl onHelp.pl

AutoPerlInterpret.cc: ../GuiScriptingBindings.h PerlInterpret_cc.in createCallbacks.pl 
	$(PERL) createCallbacks.pl interpret_cc < $< > $@

AutoGuiScriptingWrapper.h: ../GuiScriptingBindings.h GuiScriptingWrapper_h.in createCallbacks.pl
	$(PERL) createCallbacks.pl wrapper_h < $< > $@

AutoGuiScriptingWrapper.cc: ../GuiScriptingBindings.h createCallbacks.pl AutoGuiScriptingWrapper.h
	$(PERL) createCallbacks.pl wrapper_cc < $< > $@

install: libxmperlinterpreter@DLL_SUFFIX@
	mkdir -p $(INSTDIR)/dll/interpreter	
	cp -f libxmperlinterpreter@DLL_SUFFIX@ $(INSTDIR)/dll/interpreter
	mkdir -p $(INSTDIR)/appdata/perl

clean: Makefile.nms
	(unset MAKEFLAGS && @MAKEQFILE@ Makefile.nms clean)
	rm -f Makefile.nms
	rm -f onHelp.pl
	rm -f sysinit_plf.h

Makefile: Makefile.ms.gnu
	(cd $(TOPDIR) && bash ./configure.ms.gnu)
