#include "XMPerlFactory.h"
#include "XMPerl.h"
#include "../GuiScriptingBindings.h"

#include <iostream>
using namespace std;

class A: public GuiScriptingBindings {
public:
  // funcs for QWidget
  virtual void XM_Window_setTitle(int id,const char * string, int len) { };
  virtual void XM_Window_show(int id) { };
  virtual void XM_Window_hide(int id) { };
  virtual void XM_Window_close(int id) { };
  virtual void XM_Window_minimize(int id) { };
  virtual void XM_Window_maximize(int id) { };
  virtual void XM_Window_move(int id,int x, int y) { };
  virtual void XM_Window_resize(int id,int x, int y) { };
  virtual bool XM_Window_isValid(int id) { return 1;};
  virtual void XM_Window_raise(int id) { };
  virtual void XM_Window_lower(int id) { };
  virtual int  XM_Window_getPositionX(int id) { return 1;};
  virtual int  XM_Window_getPositionY(int id) { return 1;};
  virtual int  XM_Window_getSizeX(int id) { return 1;};
  virtual int  XM_Window_getSizeY(int id) { return 1;};

  // funcs for TextWidget
  virtual int XM_TextWindow_initialize() { return 1; };
  virtual void XM_TextWindow_newline(int id) { };
  virtual void XM_TextWindow_clear(int id) { };
  virtual void XM_TextWindow_clearLine(int id) { };
  virtual void XM_TextWindow_clearEOL(int id) { };
  virtual void XM_TextWindow_resetAttributes(int id) { };
  virtual void XM_TextWindow_print(int id,const char * string, int len) { 
    cout << string << endl;
  }
  virtual void XM_TextWindow_printANSI(int id,const char * string, int len) { 
    cout << string << endl;
  }
  virtual void XM_TextWindow_setBGColor(int id,int color) { };
  virtual void XM_TextWindow_setFGColor(int id,int color) { };
  virtual void XM_TextWindow_setDefaultBGColor(int id,int color) { };
  virtual void XM_TextWindow_setDefaultFGColor(int id,int color) { };
  virtual void XM_TextWindow_scrollLines(int id,int lines) { };
  virtual void XM_TextWindow_scrollColumns(int id,int cols) { };
  virtual void XM_TextWindow_setBold(int id,bool bold) { };
  virtual void XM_TextWindow_setBlinking(int id,bool bold) { };
  virtual void XM_TextWindow_setUnderline(int id,bool bold) { };
  virtual void XM_TextWindow_setReverse(int id,bool bold) { };
  virtual void XM_TextWindow_setIntensive(int id,bool bold) { };
  virtual void XM_TextWindow_resizeChars(int id,int x, int y) { };
  virtual void XM_TextWindow_setCursor(int id,unsigned int x, unsigned int y) { };
  virtual int  XM_TextWindow_getCursorX(int id) { return 1;};
  virtual int  XM_TextWindow_getCursorY(int id) { return 1;};
  virtual int  XM_TextWindow_getColumns(int id) { return 1;};
  virtual int  XM_TextWindow_getLines(int id) { return 1;};
  virtual char XM_TextWindow_getCharAt(int id,unsigned int x, unsigned int y) { return 1;};
  virtual int XM_TextWindow_getFGColorAt(int id,unsigned int x, unsigned int y) { return 1;};
  virtual int XM_TextWindow_getBGColorAt(int id,unsigned int x, unsigned int y) { return 1;};
  virtual bool XM_TextWindow_setFont(int id,const char * string, int len, int size) { return 1;};
  virtual void XM_TextWindow_enableMouseEvents(int id) { };
  virtual void XM_TextWindow_disableMouseEvents(int id) { };

  // funcs for TextBufferWidget
  virtual int  XM_TextBufferWindow_initialize() { return 1;};
  virtual int  XM_TextBufferWindow_getWordWrapColumn(int id) { return 1;};
  virtual void XM_TextBufferWindow_setWordWrapColumn(int id, int col) { };


  // funcs for Plugins
  virtual int  XM_Plugin_initialize(const char *libname,int,
				    const char *classname,int) { return 1;};

  // global functions
  virtual void XM_setStatusMsg(const char * const, int) { };
  virtual void XM_resetStatusMsg() { };
  virtual void XM_telnet(const char * const host, int hostStrLen,
			 int port) { };
  virtual void XM_send(const char * string, int len) { cout << string << endl; };
  virtual void XM_showError(const char * string, int len) { };
  virtual void XM_echoMode(bool state) { };
};

extern "C"
{
  void *init_libxmperlinterpreter();
}

int main() {
  XMPerlFactory *fac  = (XMPerlFactory *)init_libxmperlinterpreter();

  XMPerl *i = (XMPerl *)fac->createObject(NULL, "perl", "", "");

  A a;

  i->setCallback(&a);
  i->textEntered("#prs 'Hallo\\n';");
  i->timer();
  i->timer();
  i->timer();
  i->timer();
  i->timer();
  
  return 0;
}
