PYTHON = python
TOPDIR = ../../..
INSTDIR = $(TOPDIR)/@INST_DIR@
TMAKE = @QT_MAKE@

all: libxmpythoninterpreter@DLL_SUFFIX@

libxmpythoninterpreter@DLL_SUFFIX@: doCompile

doCompile: Makefile.nms sysinit_pyf.h AutoXMPython.cc
	(unset MAKEFLAGS && @MAKEQFILE@ Makefile.nms)

Makefile.nms: libxmpythoninterpreter.pro
	$(TMAKE) -o Makefile.nms libxmpythoninterpreter.pro

sysinit_pyf.h: AutoSysinit.py py2h.py onHelp.py
	cat $< | $(PYTHON) py2h.py sysinit WIN32 > $@

onHelp.py: ../help.desc ../help-base.desc ../help-toplevel.desc ../help-stepbystep.desc desc2online.py
	cat ../help.desc | $(PYTHON) desc2online.py online . > $@

AutoXMPython.cc: ../GuiScriptingBindings.h XMPython_cc.in createCallbacks.py
	$(PYTHON) createCallbacks.py XMPython_cc.in < $< > $@

AutoSysinit.py: ../GuiScriptingBindings.h sysinit_py.in createCallbacks.py
	cat $< | $(PYTHON) createCallbacks.py sysinit_py.in > $@

install: libxmpythoninterpreter@DLL_SUFFIX@
	mkdir -p $(INSTDIR)/dll/interpreter	
	cp -f libxmpythoninterpreter@DLL_SUFFIX@ $(INSTDIR)/dll/interpreter
	mkdir -p $(INSTDIR)/appdata/python

clean: Makefile.nms
	(unset MAKEFLAGS && @MAKEQFILE@ Makefile.nms clean)
	rm -rf Makefile.nms
	rm -rf onHelp.py
	rm -rf sysinit_pyf.h

Makefile: Makefile.ms.gnu
	(cd $(TOPDIR) && bash ./configure.ms.gnu)
