#!/usr/bin/python
import re
import sys

SRCDIR = sys.argv[2]

# { type, name, heading, description, subs }
top = {}
top['type'] = "collection"
top['name'] = ""
top['heading'] = "Xpertmud Online Help"
top['description'] = "Hallo Test\n"
top['subs'] = {}
stack = []
stack.append( top )

class RegState:
  def perlSub(self, regExp, toExp, string):
    self.match = re.search(regExp, string)
    (self.string, self.count) = re.subn(regExp, toExp, string)
    return (self.count > 0)

  def perlMatch(self, regExp, string):
    self.match = re.search(regExp, string)
    return self.match != None

reS = RegState()

def parseLine(line):
  global top
  global stack
  reS.perlSub(r'\(pe\?([^)]*)\)', '', line)
  line = reS.string
  reS.perlSub(r'\(py\?([^)]*)\)', r'\1', line)
  line = reS.string
  if reS.perlMatch(r'^pe>(.*)$', line):
    line = ""
  if reS.perlMatch(r'^py>(.*)$', line):
    line = reS.match.group(1) + '\n'

  m = re.match(r'^___INCLUDE (.*)$', line)
  if(m != None):
    f = open(SRCDIR + "/" + m.group(1), "r");
    line = f.readline()
    while(line != ""):
      parseLine(line)
      line = f.readline()
      
  elif(reS.perlMatch(r'<(\w+)>\s*([\w\d#%_]+)(?:\(([^\)]*)\))?', line)):
    #print "Matched " + reS.match.group(1)
    #print len(stack)
    entry = {}
    if not stack[len(stack)-1]['subs'].has_key(reS.match.group(1)):
      stack[len(stack)-1]['subs'][reS.match.group(1)] = []
    stack[len(stack)-1]['subs'][reS.match.group(1)].append(entry)
    stack.append( entry )
    entry['type'] = reS.match.group(1)
    entry['name'] = reS.match.group(2)
    entry['heading'] = reS.match.group(2)#+"("+reS.match.group(3)+")"
    entry['description'] = ""
    if (entry['type'] == 'class' or entry['type'] == 'module' or
        entry['type'] == 'topic'):
      entry['subs'] = {}
    else:
      entry['subs'] = None
  elif(reS.perlMatch(r'</(\w+)>', line)):
    stack.pop()
  else:
    line = re.sub(r'\\n', r'\\\\n', line)
    stack[len(stack)-1]['description'] += line

line = sys.stdin.readline()
while(line != ""):
  parseLine(line)
  line = sys.stdin.readline()


############################################################
############################################################
############################################################
# http://enterprise.aacc.cc.md.us/~rhs/ansi.html
def subOnlineColors(text):
  text = re.subn("%cn", "\x1b[0m", text)[0]
  text = re.subn("%cx", "\x1b[30m", text)[0]
  text = re.subn("%cr", "\x1b[31m", text)[0]
  text = re.subn("%cg", "\x1b[32m", text)[0]
  text = re.subn("%cy", "\x1b[33m", text)[0]
  text = re.subn("%cb", "\x1b[34m", text)[0]
  text = re.subn("%cm", "\x1b[35m", text)[0]
  text = re.subn("%cc", "\x1b[36m", text)[0]
  text = re.subn("%cw", "\x1b[37m", text)[0]
  text = re.subn("%cX", "\x1b[40m", text)[0]
  text = re.subn("%cR", "\x1b[41m", text)[0]
  text = re.subn("%cG", "\x1b[42m", text)[0]
  text = re.subn("%cY", "\x1b[43m", text)[0]
  text = re.subn("%cB", "\x1b[44m", text)[0]
  text = re.subn("%cM", "\x1b[45m", text)[0]
  text = re.subn("%cC", "\x1b[46m", text)[0]
  text = re.subn("%cW", "\x1b[47m", text)[0]

  text = re.subn("%ch", "\x1b[1m", text)[0]
  
  return text;

def createOnlineEntries(prefix, type, heading, typeElement,
                        nameElement, elements):
  ret = [ 0, "" ]
  

  numInLine = 0
  ret[1] = heading+":\n"
  lastLen = 0
  for element in elements:
    #print "  type: $element[typeElement]\n"
    if(type == "" or element[typeElement] == type):
      if(numInLine > 2):
	numInLine = 0
	ret[1] = ret[1] + "\n\t"
      elif(numInLine > 0):
        if(lastLen >= 16):
          ret[1] += "\t"
        elif(lastLen >= 8):
          ret[1] += "\t\t"
        else:
          ret[1] += "\t\t\t"
      else:
	ret[1] = ret[1] + "\t"
      id = element[nameElement]
      reS.perlSub(r' ', r'_', id)
      id = reS.string
      ret[1] = ret[1] + element[nameElement]
      numInLine += 1
      lastLen = len(element[nameElement])
      ret[0] = ret[0] + 1
  ret[1] = ret[1] + "\n\n"
  if(ret[0] == 0):
    ret[1] = ""
  
  return ret

if(sys.argv[1] == "online"):
  sys.stdout.write("# **********************************************\n")
  sys.stdout.write("# *** DONT EDIT, GENERATED BY DESC2ONLINE.PL ***\n\n")
  sys.stdout.write("""
helps = %s
""" % str(top))

  sys.stdout.write( "  \n")
  sys.stdout.write( "# ***    END OF SCRIPT GENERATED SECTION     ***\n")
  sys.stdout.write( "# **********************************************\n")


def somedidumdidi(x):
  num = {}
  numString = {}

  for s in [['Module', 'Modules'],
            ['Class', 'Classes'],
            ['Topic', 'Topics']]:
    [type, heading] = s
    (num[type], numString[type]) = createOnlineEntries("Python_", type, heading, 2, 0, modules)
  
  (funInS, functionsS) = createOnlineEntries("Python_", "", "Functions", None, 0, topfunctions)
#  sys.stdout.write( """
#  if(not helpOn):
#    statusWindow().setFGColor(GREEN)
#    statusWindow().setIntensive(1)
#    statusWindow().write(\"\"\"
#xpertmud online help
#********************\"\"\")
#    statusWindow().resetAttributes()
#    statusWindow().write(\"\"\"
#
#for help on a scpecific topic type
##help (\\"TOPIC\\")
#
#%s%s%s%s\"\"\")
#""" % (
#    functionsS, numString['Class'], numString['Module'], numString['Topic']
#    ))
  sys.stdout.write("""
helps["default"] = {}
helps["default"]["heading"] = "Xpertmud Online Help"
""")

  for module in modules:
    id = "Python_" + module[0]
    reS.perlSub(r' ', r'_', id)
    id = reS.string

    defname = "Functions"
    if(module[2] == "Topic"):
      defname = "Subtopics"
    
    (entriesInMod, moduleOverview) = createOnlineEntries("Python_%s_" % module[0], "", defname, None, 0, module[1])
    underline = "*" * len(module[2]+": "+module[0])

    intro = ""
    i = ""
    if(module[3] != ""):
      i += module[3]
    if(module[2] != "Topic"):
      intro += """for help on a specific function type\n#help (\\\"%s.function\\\")\n\n%s""" % (module[0], i)
    else:
      if(entriesInMod > 0):
	intro += "for help on a specific subtopic type\n#help (\\\"%s: subtopic\\\")\n\n%s" % (module[0], i)
      else:
	intro += i
#    sys.stdout.write( """
#  elif(helpOn == "%s"):
#    statusWindow().setFGColor(GREEN)
#    statusWindow().setIntensive(1)
#    statusWindow().write(\"\"\"
#%s: %s
#%s\"\"\")
#    statusWindow().resetAttributes()
#    statusWindow().write(\"\"\"
#%s%s\"\"\")
#""" % ( module[0], module[2], module[0], underline, intro, moduleOverview ))

    for function in module[1]:

      fnString = module[0]+"."+function[0]+"( "+function[1]+" )"
      if(module[2] == "Topic"):
	fnString = module[0]+": "+function[0]
      underline = "*" * len(fnString)
      introF = ""
      onWhat = module[0]+"."+function[0]
      if(module[2] != "Topic"):
        introF += "Synopsis: %s\n\n" % fnString
      else:
	onWhat = module[0]+": "+function[0]
#      sys.stdout.write( """
#  elif(helpOn == "%s"):
#    statusWindow().setFGColor(GREEN)
#    statusWindow().setIntensive(1)
#    statusWindow().write(\"\"\"
#%s
#%s\"\"\")
#    statusWindow().resetAttributes()
#    statusWindow().write(\"\"\"
#
#%s\"\"\")
#""" % (onWhat, fnString, underline, subOnlineColors(function[2])))
      
  for function in topfunctions:
    fnString = function[0]+"( "+function[1]+" )"
    underline = "*" * len(fnString)
#    sys.stdout.write( """
#  elif(helpOn == "%s"):
#    statusWindow().setFGColor(GREEN)
#    statusWindow().setIntensive(1)
#    statusWindow().write(\"\"\"
#%s
#%s\"\"\")
#    statusWindow().resetAttributes()
#    statusWindow().write(\"\"\"
#
#%s\"\"\")
#""" % (function[0], fnString, underline, subOnlineColors(function[2])))



############################################################
############################################################
############################################################

def createDocbookEntries(prefix, type, heading, typeElement,
                         nameElement, elements):
  ret = [ 0, "" ]
  

  numInLine = 0
  ret[1] = "<table><title>"+heading+"</title><tgroup cols=\"3\"><tbody>\n<row>"
  for element in elements:
    #print "  type: $element[typeElement]\n"
    if(type == "" or element[typeElement] == type):
      if(numInLine > 2):
	numInLine = 0
	ret[1] = ret[1] + "</row>\n<row><entry>"
      else:
	ret[1] = ret[1] + "<entry>"
      id = element[nameElement]
      reS.perlSub(r' ', r'_', id)
      id = reS.string
      id = re.subn(r'#', r'SHARP', id)[0]
      id = re.subn(r'%', r'PERCENT', id)[0]
      ret[1] += "<link linkend=\""+prefix+id+"\">"+element[nameElement]+"</link></entry>"
      numInLine += 1
      ret[0] = ret[0] + 1
  ret[1] = ret[1] + "</row>\n</tbody></tgroup></table>\n";
  if(ret[0] == 0):
    ret[1] = ""
  
  return ret

if(sys.argv[1] == "docbook"):
  sys.stdout.write("<!-- **********************************************\n")
  sys.stdout.write("     *** DONT EDIT, GENERATED BY DESC2ONLINE.PY ***\n-->\n")

  num = {}
  numString = {}
  for s in [['Module', 'Modules'],
            ['Class', 'Classes'],
            ['Topic', 'Topics']]:
    [type, heading] = s
    (num[type], numString[type]) = createDocbookEntries("Python_", type, heading, 2, 0, modules)
  
  (funInS, functionsS) = createDocbookEntries("Python_", "", "Functions", None, 0, topfunctions)
  sys.stdout.write( """
<chapter id="python-developers">
<title>Python Developers Guide to Xpertmud</title>
<para>
%s
%s
%s
%s
</para>
""" % (
    functionsS, numString['Class'], numString['Module'], numString['Topic']
    ))

  for module in modules:
    id = "Python_" + module[0]
    reS.perlSub(r' ', r'_', id)
    id = reS.string

    defname = "Functions"
    if(module[2] == "Topic"):
      defname = "Subtopics"
    
    (entriesInMod, moduleOverview) = createDocbookEntries("Python_%s_" % module[0], "", defname, None, 0, module[1])
    underline = "*" * len(module[2]+": "+module[0])

    intro = ""
    if(module[4] != ""):
      intro += "<para><programlisting>"+module[4]+"</programlisting></para>\n"
    sys.stdout.write( """
<sect1 id="%s">
<title>%s: %s</title>
%s
<para>
%s
</para>

""" % ( id, module[2], module[0], intro, moduleOverview ))

    for function in module[1]:

      fnString = module[0]+"."+function[0]+"( "+function[1]+" )"
      introF = ""
      id = "Python_%s_%s" % (module[0], function[0])
      id = re.subn(r' ', r'_', id)[0]
      if(module[2] != "Topic"):
        introF += "Synopsis: %s\n\n" % fnString
      sys.stdout.write( """
<sect2 id="%s">
<title>%s</title>
<para>
<programlisting>
%s%s
</programlisting>
</para>
</sect2>
""" % (id, function[0], introF, function[3]))
    sys.stdout.write("""
</sect1>
""")
    
  for function in topfunctions:
    idTail = function[0]
    idTail = re.subn(r'#', r'SHARP', idTail)[0]
    idTail = re.subn(r'%', r'PERCENT', idTail)[0]
    idTail = re.subn(r' ', r'_', idTail)[0]
    
    fnString = function[0]+"( "+function[1]+" )"
    sys.stdout.write( """
<sect1 id="Python_%s">
<title>%s</title>
<para>
<programlisting>
Synopsis: %s

%s
</programlisting>
</para>
</sect1>
""" % (idTail, function[0], fnString, function[3]))

  sys.stdout.write( "</chapter>\n")
  sys.stdout.write( "<!-- ***    END OF SCRIPT GENERATED SECTION     ***\n")
  sys.stdout.write( "     ********************************************** -->\n")

