
#include "XMRuby.h"
#include "../GuiScriptingBindings.h"
#include "ruby.h"

// Hmm..not yet sure if I need this. Stole it from the python dir
#include <kglobal.h>
#include <kstandarddirs.h>


XMRuby::XMRuby(QObject* parent,
	       const char* name):
  XMScripting(parent,name),callBack(NULL),initialized(false) {
    
  }

XMRuby::~XMRuby() {
  if(initialized) {
    // clean up one last time
    rb_gc();
    ruby_finalize();
  }
}


void XMRuby::setCallback(GuiScriptingBindings *cB) {
  if(!initialized) {
    // Initialize Interpreter
    ruby_init();
    // Initialize the loadpath.
    ruby_init_loadpath();
    //set script name
    ruby_script(static_cast<char *>("xpertmud-embedded"));

    // adjust the script include Paths
    QStringList incPath=KGlobal::dirs()->findDirs("appdata","ruby");
    
    VALUE loadPath = rb_gv_get("$:");
    if(loadPath != Qnil)
      for (QStringList::Iterator it=incPath.begin();
	 it!=incPath.end(); ++it) {
	rb_ary_unshift(loadPath,rb_str_new2((*it).latin1()));
    }

    // Parse the SYSINIT script
    evalSysInit();

    initialized=true;
  }
  callBack = cB;
}

const char *rubySysInitScript[] = {
				   "print \"Hallo\\n\"",
				   "print \"peter\\n\""
};

static VALUE int_ruby_eval(VALUE rcode) {
  rb_eval_string(STR2CSTR(rcode));
  return Qnil;
}


bool XMRuby::evalSysInit() {
  int i=0;
  int sum=0;
  while(rubySysInitScript[i] != NULL) {
    sum += strlen(rubySysInitScript[i]);
    ++i;
  }
  char *commandString = new char[sum+1];
  i=0;
  int c=0;
  while(rubySysInitScript[i] != NULL) {
    int y=0;
    while(rubySysInitScript[i][y] != 0) {
      commandString[c] = rubySysInitScript[i][y];
      ++y; ++c;
    }
    ++i;
  }
  commandString[c] = 0;
  VALUE tmp = rb_str_new2(commandString);
  rb_gc_register_address(&tmp);
  int ret;
  rb_protect(int_ruby_eval,tmp,&ret);
  rb_gc_unregister_address(&tmp);
  delete[] commandString;
  //just be nice and clean up, because we have a huge string
  // which noone will ever need again
  rb_gc();
  return (ret ? false:true);
}

void XMRuby::timer() {
}
